// This code was generated by: 
// https://github.com/recolude/swagger-unity-codegen
// Issues and PRs welcome :)

using UnityEngine;
using UnityEngine.Networking;
using System.Collections;
using System.Text;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using JsonSubTypes;

namespace Recolude.API
{

    [System.Serializable]
    public class AggMetadataQuery : GraphQuery
    {

        [System.Serializable]
        public class AggMetadataQueryQuery
        {

            [JsonProperty("field")]
            public string Field { get; private set; }

            [JsonProperty("maxDate")]
            public string maxDate;

            public System.DateTime MaxDate { get => System.DateTime.Parse(maxDate); }

            [JsonProperty("minDate")]
            public string minDate;

            public System.DateTime MinDate { get => System.DateTime.Parse(minDate); }

            [JsonProperty("modifier")]
            [JsonConverter(typeof(AggModifierJsonConverter))]
            public AggModifier Modifier { get; private set; }

            [JsonProperty("onEntity")]
            [JsonConverter(typeof(MetadataRecordingEntityJsonConverter))]
            public MetadataRecordingEntity OnEntity { get; private set; }

            [JsonProperty("timeSpan")]
            [JsonConverter(typeof(TimeSpanWindowJsonConverter))]
            public TimeSpanWindow TimeSpan { get; private set; }

            [JsonProperty("withField")]
            public string WithField { get; private set; }

            [JsonProperty("withFieldValue")]
            public string WithFieldValue { get; private set; }

            [JsonProperty("withName")]
            public string WithName { get; private set; }

        }
        [JsonProperty("query")]
        public AggMetadataQueryQuery Query { get; private set; }

    }

    public enum AggModifier
    {
        Avg = 0,
        Sum = 1,
        Min = 2,
        Max = 3
    }
    public class AggModifierJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            AggModifier castedVal = (AggModifier)val;
            switch (castedVal)
            {
                case AggModifier.Avg:
                    w.WriteValue("avg");
                    break;
                case AggModifier.Sum:
                    w.WriteValue("sum");
                    break;
                case AggModifier.Min:
                    w.WriteValue("min");
                    break;
                case AggModifier.Max:
                    w.WriteValue("max");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "avg":
                    return AggModifier.Avg;
                case "sum":
                    return AggModifier.Sum;
                case "min":
                    return AggModifier.Min;
                case "max":
                    return AggModifier.Max;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    [System.Serializable]
    public class Analytics
    {

        [JsonProperty("continuous_map_ids")]
        public string[] ContinuousMapIds { get; private set; }

        [JsonProperty("dashboard_ids")]
        public string[] DashboardIds { get; private set; }

        [JsonProperty("discrete_map_ids")]
        public string[] DiscreteMapIds { get; private set; }

    }

    [System.Serializable]
    public class ApiKey
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("deleted_at")]
        public string deletedAt;

        public System.DateTime DeletedAt { get => System.DateTime.Parse(deletedAt); }

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("permissions")]
        public Permission[] Permissions { get; private set; }

        [JsonProperty("project")]
        public Project Project { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("token")]
        public string Token { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class ApiKeyResponse
    {

        [JsonProperty("api_key")]
        public ApiKey ApiKey { get; private set; }

    }

    [System.Serializable]
    public class ApiKeysResponse
    {

        [JsonProperty("api_keys")]
        public ApiKey[] ApiKeys { get; private set; }

        [JsonProperty("request")]
        public ListApiKeysRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    public enum BinSize
    {
        NUMBER_0_DOT_125,
        NUMBER_0_DOT_25,
        NUMBER_0_DOT_5,
        NUMBER_1,
        NUMBER_2,
        NUMBER_4,
        NUMBER_8
    }

    [System.Serializable]
    public class ContinuousMap
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("query")]
        public ContinuousMapQuery Query { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

    }

    [System.Serializable]
    public class ContinuousMapConfig
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("query")]
        public ContinuousMapQuery Query { get; private set; }

    }

    [System.Serializable]
    public class ContinuousMapQuery
    {

        [System.Serializable]
        public class ContinuousMapQueryQuery
        {

            [JsonProperty("entityMatches")]
            public MetadataMatch[] EntityMatches { get; private set; }

            [JsonProperty("environmentURI")]
            public string EnvironmentURI { get; private set; }

            [JsonProperty("maxDate")]
            public string maxDate;

            public System.DateTime MaxDate { get => System.DateTime.Parse(maxDate); }

            [JsonProperty("minDate")]
            public string minDate;

            public System.DateTime MinDate { get => System.DateTime.Parse(minDate); }

            [JsonProperty("recordingMatches")]
            public MetadataMatch[] RecordingMatches { get; private set; }

            [JsonProperty("timeSpan")]
            [JsonConverter(typeof(TimeSpanWindowJsonConverter))]
            public TimeSpanWindow TimeSpan { get; private set; }

        }
        [JsonProperty("query")]
        public ContinuousMapQueryQuery Query { get; private set; }

    }

    [System.Serializable]
    public class CountQuery : GraphQuery
    {

        [System.Serializable]
        public class CountQueryQuery
        {

            [JsonProperty("maxDate")]
            public string maxDate;

            public System.DateTime MaxDate { get => System.DateTime.Parse(maxDate); }

            [JsonProperty("minDate")]
            public string minDate;

            public System.DateTime MinDate { get => System.DateTime.Parse(minDate); }

            [JsonProperty("name")]
            public string Name { get; private set; }

            [JsonProperty("onEntity")]
            [JsonConverter(typeof(RecordingEntityJsonConverter))]
            public RecordingEntity OnEntity { get; private set; }

            [JsonProperty("timeSpan")]
            [JsonConverter(typeof(TimeSpanWindowJsonConverter))]
            public TimeSpanWindow TimeSpan { get; private set; }

            [JsonProperty("withField")]
            public string WithField { get; private set; }

            [JsonProperty("withFieldValue")]
            public string WithFieldValue { get; private set; }

        }
        [JsonProperty("query")]
        public CountQueryQuery Query { get; private set; }

    }

    [System.Serializable]
    public class CreateApiKeyRequest
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

    }

    [System.Serializable]
    public class CreateOrganizationPermissionRequest
    {

        [JsonProperty("entity_id")]
        public string EntityId { get; private set; }

        [JsonProperty("entity_type")]
        [JsonConverter(typeof(EnumPermissionEntityJsonConverter))]
        public EnumPermissionEntity EntityType { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("security_role_id")]
        public string SecurityRoleId { get; private set; }

    }

    [System.Serializable]
    public class CreateOrganizationRequest
    {

        [JsonProperty("display_name")]
        public string DisplayName { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

    }

    [System.Serializable]
    public class CreateProjectPermissionRequest
    {

        [JsonProperty("entity_id")]
        public string EntityId { get; private set; }

        [JsonProperty("entity_type")]
        [JsonConverter(typeof(EnumPermissionEntityJsonConverter))]
        public EnumPermissionEntity EntityType { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("security_role_id")]
        public string SecurityRoleId { get; private set; }

    }

    [System.Serializable]
    public class CreateProjectRequest
    {

        [JsonProperty("classification")]
        public string Classification { get; private set; }

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("type")]
        [JsonConverter(typeof(EnumProjectTypeJsonConverter))]
        public EnumProjectType Type { get; private set; }

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    [System.Serializable]
    public class CreateUserRequest
    {

        [JsonProperty("email")]
        public string Email { get; private set; }

        [JsonProperty("sub")]
        public string Sub { get; private set; }

        [JsonProperty("username")]
        public string Username { get; private set; }

    }

    [System.Serializable]
    public class Customer
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("stripe_customer_id")]
        public string StripeCustomerId { get; private set; }

    }

    [System.Serializable]
    public class Dashboard
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("graphIds")]
        public string[] GraphIds { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

    }

    [System.Serializable]
    public class DashboardConfig
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("graphIds")]
        public string[] GraphIds { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

    }

    [System.Serializable]
    public class DevKey
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("person")]
        public Person Person { get; private set; }

        [JsonProperty("person_id")]
        public string PersonId { get; private set; }

        [JsonProperty("token")]
        public string Token { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class DevKeyResponse
    {

        [JsonProperty("dev_key")]
        public DevKey DevKey { get; private set; }

    }

    [System.Serializable]
    public class Dimension
    {

        [JsonProperty("format")]
        public string Format { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

    }

    [System.Serializable]
    public class DiscreteMap
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("query")]
        public DiscreteMapQuery Query { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

    }

    [System.Serializable]
    public class DiscreteMapConfig
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("query")]
        public DiscreteMapQuery Query { get; private set; }

    }

    [System.Serializable]
    public class DiscreteMapQuery
    {

        [System.Serializable]
        public class DiscreteMapQueryQuery
        {

            [JsonProperty("binSize")]
            public BinSize BinSize { get; private set; }

            [JsonProperty("entityName")]
            public string EntityName { get; private set; }

            [JsonProperty("environmentURI")]
            public string EnvironmentURI { get; private set; }

            [JsonProperty("maxDate")]
            public string maxDate;

            public System.DateTime MaxDate { get => System.DateTime.Parse(maxDate); }

            [JsonProperty("minDate")]
            public string minDate;

            public System.DateTime MinDate { get => System.DateTime.Parse(minDate); }

            [JsonProperty("onEntity")]
            [JsonConverter(typeof(RecordingEntityJsonConverter))]
            public RecordingEntity OnEntity { get; private set; }

            [JsonProperty("scaledField")]
            public string ScaledField { get; private set; }

            [JsonProperty("timeSpan")]
            [JsonConverter(typeof(TimeSpanWindowJsonConverter))]
            public TimeSpanWindow TimeSpan { get; private set; }

            [JsonProperty("withField")]
            public string WithField { get; private set; }

            [JsonProperty("withFieldValue")]
            public string WithFieldValue { get; private set; }

        }
        [JsonProperty("query")]
        public DiscreteMapQueryQuery Query { get; private set; }

    }

    [System.Serializable]
    public class Echo
    {

        [JsonProperty("value")]
        public string Value { get; private set; }

    }

    public enum EnumFeaturePermission
    {
        NULL = 0,
        CAN_VIEW_ORGANIZATION = 1,
        CAN_VIEW_ORG_LICENSE = 2,
        CAN_UPDATE_ORG = 3,
        CAN_DELETE_ORG = 4,
        CAN_VIEW_ORGANIZATION_USERS = 5,
        CAN_VIEW_PROJECT = 6,
        CAN_VIEW_PROJECT_LICENSE = 7,
        CAN_UPDATE_PROJECT = 8,
        CAN_DELETE_PROJECT = 9,
        CAN_VIEW_API_KEYS = 10,
        CAN_CREATE_API_KEYS = 11,
        CAN_VIEW_PROJECT_USERS = 12,
        CAN_VIEW_RECORDING = 13,
        CAN_DELETE_RECORDING = 14,
        CAN_CREATE_RECORDING = 15,
        CAN_CREATE_ORG_PROJECT = 16,
        CAN_ADD_PROJECT_USER = 17,
        CAN_REMOVE_PROJECT_USER = 18,
        CAN_ADMIN_PROJECT_USER = 19,
        CAN_REMOVE_ADMIN_PROJECT_USER = 20,
        CAN_ADD_ORG_USER = 21,
        CAN_REMOVE_ORG_USER = 22,
        CAN_ADMIN_ORG_USER = 23,
        CAN_REMOVE_ADMIN_ORG_USER = 24
    }
    public class EnumFeaturePermissionJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            EnumFeaturePermission castedVal = (EnumFeaturePermission)val;
            switch (castedVal)
            {
                case EnumFeaturePermission.NULL:
                    w.WriteValue("NULL");
                    break;
                case EnumFeaturePermission.CAN_VIEW_ORGANIZATION:
                    w.WriteValue("CAN_VIEW_ORGANIZATION");
                    break;
                case EnumFeaturePermission.CAN_VIEW_ORG_LICENSE:
                    w.WriteValue("CAN_VIEW_ORG_LICENSE");
                    break;
                case EnumFeaturePermission.CAN_UPDATE_ORG:
                    w.WriteValue("CAN_UPDATE_ORG");
                    break;
                case EnumFeaturePermission.CAN_DELETE_ORG:
                    w.WriteValue("CAN_DELETE_ORG");
                    break;
                case EnumFeaturePermission.CAN_VIEW_ORGANIZATION_USERS:
                    w.WriteValue("CAN_VIEW_ORGANIZATION_USERS");
                    break;
                case EnumFeaturePermission.CAN_VIEW_PROJECT:
                    w.WriteValue("CAN_VIEW_PROJECT");
                    break;
                case EnumFeaturePermission.CAN_VIEW_PROJECT_LICENSE:
                    w.WriteValue("CAN_VIEW_PROJECT_LICENSE");
                    break;
                case EnumFeaturePermission.CAN_UPDATE_PROJECT:
                    w.WriteValue("CAN_UPDATE_PROJECT");
                    break;
                case EnumFeaturePermission.CAN_DELETE_PROJECT:
                    w.WriteValue("CAN_DELETE_PROJECT");
                    break;
                case EnumFeaturePermission.CAN_VIEW_API_KEYS:
                    w.WriteValue("CAN_VIEW_API_KEYS");
                    break;
                case EnumFeaturePermission.CAN_CREATE_API_KEYS:
                    w.WriteValue("CAN_CREATE_API_KEYS");
                    break;
                case EnumFeaturePermission.CAN_VIEW_PROJECT_USERS:
                    w.WriteValue("CAN_VIEW_PROJECT_USERS");
                    break;
                case EnumFeaturePermission.CAN_VIEW_RECORDING:
                    w.WriteValue("CAN_VIEW_RECORDING");
                    break;
                case EnumFeaturePermission.CAN_DELETE_RECORDING:
                    w.WriteValue("CAN_DELETE_RECORDING");
                    break;
                case EnumFeaturePermission.CAN_CREATE_RECORDING:
                    w.WriteValue("CAN_CREATE_RECORDING");
                    break;
                case EnumFeaturePermission.CAN_CREATE_ORG_PROJECT:
                    w.WriteValue("CAN_CREATE_ORG_PROJECT");
                    break;
                case EnumFeaturePermission.CAN_ADD_PROJECT_USER:
                    w.WriteValue("CAN_ADD_PROJECT_USER");
                    break;
                case EnumFeaturePermission.CAN_REMOVE_PROJECT_USER:
                    w.WriteValue("CAN_REMOVE_PROJECT_USER");
                    break;
                case EnumFeaturePermission.CAN_ADMIN_PROJECT_USER:
                    w.WriteValue("CAN_ADMIN_PROJECT_USER");
                    break;
                case EnumFeaturePermission.CAN_REMOVE_ADMIN_PROJECT_USER:
                    w.WriteValue("CAN_REMOVE_ADMIN_PROJECT_USER");
                    break;
                case EnumFeaturePermission.CAN_ADD_ORG_USER:
                    w.WriteValue("CAN_ADD_ORG_USER");
                    break;
                case EnumFeaturePermission.CAN_REMOVE_ORG_USER:
                    w.WriteValue("CAN_REMOVE_ORG_USER");
                    break;
                case EnumFeaturePermission.CAN_ADMIN_ORG_USER:
                    w.WriteValue("CAN_ADMIN_ORG_USER");
                    break;
                case EnumFeaturePermission.CAN_REMOVE_ADMIN_ORG_USER:
                    w.WriteValue("CAN_REMOVE_ADMIN_ORG_USER");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "NULL":
                    return EnumFeaturePermission.NULL;
                case "CAN_VIEW_ORGANIZATION":
                    return EnumFeaturePermission.CAN_VIEW_ORGANIZATION;
                case "CAN_VIEW_ORG_LICENSE":
                    return EnumFeaturePermission.CAN_VIEW_ORG_LICENSE;
                case "CAN_UPDATE_ORG":
                    return EnumFeaturePermission.CAN_UPDATE_ORG;
                case "CAN_DELETE_ORG":
                    return EnumFeaturePermission.CAN_DELETE_ORG;
                case "CAN_VIEW_ORGANIZATION_USERS":
                    return EnumFeaturePermission.CAN_VIEW_ORGANIZATION_USERS;
                case "CAN_VIEW_PROJECT":
                    return EnumFeaturePermission.CAN_VIEW_PROJECT;
                case "CAN_VIEW_PROJECT_LICENSE":
                    return EnumFeaturePermission.CAN_VIEW_PROJECT_LICENSE;
                case "CAN_UPDATE_PROJECT":
                    return EnumFeaturePermission.CAN_UPDATE_PROJECT;
                case "CAN_DELETE_PROJECT":
                    return EnumFeaturePermission.CAN_DELETE_PROJECT;
                case "CAN_VIEW_API_KEYS":
                    return EnumFeaturePermission.CAN_VIEW_API_KEYS;
                case "CAN_CREATE_API_KEYS":
                    return EnumFeaturePermission.CAN_CREATE_API_KEYS;
                case "CAN_VIEW_PROJECT_USERS":
                    return EnumFeaturePermission.CAN_VIEW_PROJECT_USERS;
                case "CAN_VIEW_RECORDING":
                    return EnumFeaturePermission.CAN_VIEW_RECORDING;
                case "CAN_DELETE_RECORDING":
                    return EnumFeaturePermission.CAN_DELETE_RECORDING;
                case "CAN_CREATE_RECORDING":
                    return EnumFeaturePermission.CAN_CREATE_RECORDING;
                case "CAN_CREATE_ORG_PROJECT":
                    return EnumFeaturePermission.CAN_CREATE_ORG_PROJECT;
                case "CAN_ADD_PROJECT_USER":
                    return EnumFeaturePermission.CAN_ADD_PROJECT_USER;
                case "CAN_REMOVE_PROJECT_USER":
                    return EnumFeaturePermission.CAN_REMOVE_PROJECT_USER;
                case "CAN_ADMIN_PROJECT_USER":
                    return EnumFeaturePermission.CAN_ADMIN_PROJECT_USER;
                case "CAN_REMOVE_ADMIN_PROJECT_USER":
                    return EnumFeaturePermission.CAN_REMOVE_ADMIN_PROJECT_USER;
                case "CAN_ADD_ORG_USER":
                    return EnumFeaturePermission.CAN_ADD_ORG_USER;
                case "CAN_REMOVE_ORG_USER":
                    return EnumFeaturePermission.CAN_REMOVE_ORG_USER;
                case "CAN_ADMIN_ORG_USER":
                    return EnumFeaturePermission.CAN_ADMIN_ORG_USER;
                case "CAN_REMOVE_ADMIN_ORG_USER":
                    return EnumFeaturePermission.CAN_REMOVE_ADMIN_ORG_USER;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum EnumPermissionEntity
    {
        UNKNOWN = 0,
        PERSON = 1,
        APIKEY = 2
    }
    public class EnumPermissionEntityJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            EnumPermissionEntity castedVal = (EnumPermissionEntity)val;
            switch (castedVal)
            {
                case EnumPermissionEntity.UNKNOWN:
                    w.WriteValue("UNKNOWN");
                    break;
                case EnumPermissionEntity.PERSON:
                    w.WriteValue("PERSON");
                    break;
                case EnumPermissionEntity.APIKEY:
                    w.WriteValue("APIKEY");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "UNKNOWN":
                    return EnumPermissionEntity.UNKNOWN;
                case "PERSON":
                    return EnumPermissionEntity.PERSON;
                case "APIKEY":
                    return EnumPermissionEntity.APIKEY;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum EnumPermissionScope
    {
        UNKNOWN = 0,
        GLOBAL = 1,
        ORGANIZATION = 2,
        PROJECT = 3
    }
    public class EnumPermissionScopeJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            EnumPermissionScope castedVal = (EnumPermissionScope)val;
            switch (castedVal)
            {
                case EnumPermissionScope.UNKNOWN:
                    w.WriteValue("UNKNOWN");
                    break;
                case EnumPermissionScope.GLOBAL:
                    w.WriteValue("GLOBAL");
                    break;
                case EnumPermissionScope.ORGANIZATION:
                    w.WriteValue("ORGANIZATION");
                    break;
                case EnumPermissionScope.PROJECT:
                    w.WriteValue("PROJECT");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "UNKNOWN":
                    return EnumPermissionScope.UNKNOWN;
                case "GLOBAL":
                    return EnumPermissionScope.GLOBAL;
                case "ORGANIZATION":
                    return EnumPermissionScope.ORGANIZATION;
                case "PROJECT":
                    return EnumPermissionScope.PROJECT;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum EnumProjectType
    {
        UNKONWN = 0,
        PERSONAL = 1,
        ORGANIZATION = 2
    }
    public class EnumProjectTypeJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            EnumProjectType castedVal = (EnumProjectType)val;
            switch (castedVal)
            {
                case EnumProjectType.UNKONWN:
                    w.WriteValue("UNKONWN");
                    break;
                case EnumProjectType.PERSONAL:
                    w.WriteValue("PERSONAL");
                    break;
                case EnumProjectType.ORGANIZATION:
                    w.WriteValue("ORGANIZATION");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "UNKONWN":
                    return EnumProjectType.UNKONWN;
                case "PERSONAL":
                    return EnumProjectType.PERSONAL;
                case "ORGANIZATION":
                    return EnumProjectType.ORGANIZATION;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum EnumUserState
    {
        UNKNOWN = 0,
        UNCONFIRMED = 1,
        ENABLED = 2,
        DISABLED = 3
    }
    public class EnumUserStateJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            EnumUserState castedVal = (EnumUserState)val;
            switch (castedVal)
            {
                case EnumUserState.UNKNOWN:
                    w.WriteValue("UNKNOWN");
                    break;
                case EnumUserState.UNCONFIRMED:
                    w.WriteValue("UNCONFIRMED");
                    break;
                case EnumUserState.ENABLED:
                    w.WriteValue("ENABLED");
                    break;
                case EnumUserState.DISABLED:
                    w.WriteValue("DISABLED");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "UNKNOWN":
                    return EnumUserState.UNKNOWN;
                case "UNCONFIRMED":
                    return EnumUserState.UNCONFIRMED;
                case "ENABLED":
                    return EnumUserState.ENABLED;
                case "DISABLED":
                    return EnumUserState.DISABLED;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum EnumVisibility
    {
        UNKNOWN = 0,
        PUBLIC = 1,
        PRIVATE = 2,
        PROTECTED = 3
    }
    public class EnumVisibilityJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            EnumVisibility castedVal = (EnumVisibility)val;
            switch (castedVal)
            {
                case EnumVisibility.UNKNOWN:
                    w.WriteValue("UNKNOWN");
                    break;
                case EnumVisibility.PUBLIC:
                    w.WriteValue("PUBLIC");
                    break;
                case EnumVisibility.PRIVATE:
                    w.WriteValue("PRIVATE");
                    break;
                case EnumVisibility.PROTECTED:
                    w.WriteValue("PROTECTED");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "UNKNOWN":
                    return EnumVisibility.UNKNOWN;
                case "PUBLIC":
                    return EnumVisibility.PUBLIC;
                case "PRIVATE":
                    return EnumVisibility.PRIVATE;
                case "PROTECTED":
                    return EnumVisibility.PROTECTED;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    [System.Serializable]
    public class ErrorMessage
    {

        [JsonProperty("message")]
        public string Message { get; private set; }

    }

    [System.Serializable]
    public class GetFeaturesResponse
    {

        [JsonProperty("features")]
        public bool[] Features { get; private set; }

    }

    [System.Serializable]
    public class GrantResponse
    {

        [JsonProperty("grant")]
        public SecurityGrant Grant { get; private set; }

    }

    [System.Serializable]
    public class GrantsResponse
    {

        [JsonProperty("grants")]
        public SecurityGrant[] Grants { get; private set; }

        [JsonProperty("request")]
        public ListGrantsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class Graph
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("query")]
        public GraphQuery Query { get; private set; }

        [JsonProperty("renderType")]
        public string RenderType { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("result")]
        public GraphData Result { get; private set; }

    }

    [System.Serializable]
    public class GraphConfig
    {

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("query")]
        public GraphQuery Query { get; private set; }

        [JsonProperty("renderType")]
        public string RenderType { get; private set; }

    }

    [System.Serializable]
    public class GraphData
    {

        [JsonProperty("data")]
        public string[][] Data { get; private set; }

        [JsonProperty("dimensions")]
        public Dimension[] Dimensions { get; private set; }

        [JsonProperty("format")]
        public string Format { get; private set; }

    }

    [System.Serializable]
    [JsonConverter(typeof(JsonSubtypes), "queryType")]
    [JsonSubtypes.KnownSubType(typeof(GroupsAggMetadataQuery), "GroupsAggMetadataQuery")]
    [JsonSubtypes.KnownSubType(typeof(AggMetadataQuery), "AggMetadataQuery")]
    [JsonSubtypes.KnownSubType(typeof(CountQuery), "CountQuery")]
    [JsonSubtypes.KnownSubType(typeof(GroupsCountQuery), "GroupsCountQuery")]
    public class GraphQuery
    {

        [JsonProperty("queryType")]
        [JsonConverter(typeof(GraphQueryTypeJsonConverter))]
        public GraphQueryType QueryType { get; private set; }

    }

    public enum GraphQueryType
    {
        CountQuery = 0,
        AggMetadataQuery = 1,
        GroupsCountQuery = 2,
        GroupsAggMetadataQuery = 3
    }
    public class GraphQueryTypeJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            GraphQueryType castedVal = (GraphQueryType)val;
            switch (castedVal)
            {
                case GraphQueryType.CountQuery:
                    w.WriteValue("CountQuery");
                    break;
                case GraphQueryType.AggMetadataQuery:
                    w.WriteValue("AggMetadataQuery");
                    break;
                case GraphQueryType.GroupsCountQuery:
                    w.WriteValue("GroupsCountQuery");
                    break;
                case GraphQueryType.GroupsAggMetadataQuery:
                    w.WriteValue("GroupsAggMetadataQuery");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "CountQuery":
                    return GraphQueryType.CountQuery;
                case "AggMetadataQuery":
                    return GraphQueryType.AggMetadataQuery;
                case "GroupsCountQuery":
                    return GraphQueryType.GroupsCountQuery;
                case "GroupsAggMetadataQuery":
                    return GraphQueryType.GroupsAggMetadataQuery;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum GroupBy
    {
        Name = 0,
        Recording_Id = 1,
        Metadata_Value = 2,
        Time = 3
    }
    public class GroupByJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            GroupBy castedVal = (GroupBy)val;
            switch (castedVal)
            {
                case GroupBy.Name:
                    w.WriteValue("name");
                    break;
                case GroupBy.Recording_Id:
                    w.WriteValue("recording_id");
                    break;
                case GroupBy.Metadata_Value:
                    w.WriteValue("metadata_value");
                    break;
                case GroupBy.Time:
                    w.WriteValue("time");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "name":
                    return GroupBy.Name;
                case "recording_id":
                    return GroupBy.Recording_Id;
                case "metadata_value":
                    return GroupBy.Metadata_Value;
                case "time":
                    return GroupBy.Time;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    public enum GroupTimeSpan
    {
        Day = 0,
        Week = 1,
        Month = 2
    }
    public class GroupTimeSpanJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            GroupTimeSpan castedVal = (GroupTimeSpan)val;
            switch (castedVal)
            {
                case GroupTimeSpan.Day:
                    w.WriteValue("day");
                    break;
                case GroupTimeSpan.Week:
                    w.WriteValue("week");
                    break;
                case GroupTimeSpan.Month:
                    w.WriteValue("month");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "day":
                    return GroupTimeSpan.Day;
                case "week":
                    return GroupTimeSpan.Week;
                case "month":
                    return GroupTimeSpan.Month;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    [System.Serializable]
    public class GroupsAggMetadataQuery : GraphQuery
    {

        [System.Serializable]
        public class GroupsAggMetadataQueryQuery
        {

            [JsonProperty("field")]
            public string Field { get; private set; }

            [JsonProperty("groups")]
            public GroupBy[] Groups { get; private set; }

            [JsonProperty("groupsField")]
            public string GroupsField { get; private set; }

            [JsonProperty("groupsTimeSpan")]
            [JsonConverter(typeof(GroupTimeSpanJsonConverter))]
            public GroupTimeSpan GroupsTimeSpan { get; private set; }

            [JsonProperty("maxDate")]
            public string maxDate;

            public System.DateTime MaxDate { get => System.DateTime.Parse(maxDate); }

            [JsonProperty("minDate")]
            public string minDate;

            public System.DateTime MinDate { get => System.DateTime.Parse(minDate); }

            [JsonProperty("modifier")]
            [JsonConverter(typeof(AggModifierJsonConverter))]
            public AggModifier Modifier { get; private set; }

            [JsonProperty("onEntity")]
            [JsonConverter(typeof(MetadataRecordingEntityJsonConverter))]
            public MetadataRecordingEntity OnEntity { get; private set; }

            [JsonProperty("timeSpan")]
            [JsonConverter(typeof(TimeSpanWindowJsonConverter))]
            public TimeSpanWindow TimeSpan { get; private set; }

            [JsonProperty("withField")]
            public string WithField { get; private set; }

            [JsonProperty("withFieldValue")]
            public string WithFieldValue { get; private set; }

            [JsonProperty("withName")]
            public string WithName { get; private set; }

        }
        [JsonProperty("query")]
        public GroupsAggMetadataQueryQuery Query { get; private set; }

    }

    [System.Serializable]
    public class GroupsCountQuery : GraphQuery
    {

        [System.Serializable]
        public class GroupsCountQueryQuery
        {

            [JsonProperty("groups")]
            public GroupBy[] Groups { get; private set; }

            [JsonProperty("groupsField")]
            public string GroupsField { get; private set; }

            [JsonProperty("groupsTimeSpan")]
            [JsonConverter(typeof(GroupTimeSpanJsonConverter))]
            public GroupTimeSpan GroupsTimeSpan { get; private set; }

            [JsonProperty("maxDate")]
            public string maxDate;

            public System.DateTime MaxDate { get => System.DateTime.Parse(maxDate); }

            [JsonProperty("minDate")]
            public string minDate;

            public System.DateTime MinDate { get => System.DateTime.Parse(minDate); }

            [JsonProperty("onEntity")]
            [JsonConverter(typeof(RecordingEntityJsonConverter))]
            public RecordingEntity OnEntity { get; private set; }

            [JsonProperty("timeSpan")]
            [JsonConverter(typeof(TimeSpanWindowJsonConverter))]
            public TimeSpanWindow TimeSpan { get; private set; }

            [JsonProperty("withField")]
            public string WithField { get; private set; }

            [JsonProperty("withFieldValue")]
            public string WithFieldValue { get; private set; }

            [JsonProperty("withName")]
            public string WithName { get; private set; }

        }
        [JsonProperty("query")]
        public GroupsCountQueryQuery Query { get; private set; }

    }

    [System.Serializable]
    public class License
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("details")]
        public LicenseDetails Details { get; private set; }

        [JsonProperty("end_of_period")]
        public string endOfPeriod;

        public System.DateTime EndOfPeriod { get => System.DateTime.Parse(endOfPeriod); }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("status")]
        public string Status { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class LicenseDetails
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("stripeSubscriptionId")]
        public string StripeSubscriptionId { get; private set; }

        [JsonProperty("stripe_customer_id")]
        public string StripeCustomerId { get; private set; }

        [JsonProperty("stripe_subscription_item_ids")]
        public string[] StripeSubscriptionItemIds { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class ListApiKeysRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("fuzzy_description")]
        public string FuzzyDescription { get; private set; }

        [JsonProperty("fuzzy_name")]
        public string FuzzyName { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

    }

    [System.Serializable]
    public class ListGrantsRequest
    {

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("scope")]
        [JsonConverter(typeof(EnumPermissionScopeJsonConverter))]
        public EnumPermissionScope Scope { get; private set; }

    }

    [System.Serializable]
    public class ListOrganizationPermissionsRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("entity_id")]
        public string EntityId { get; private set; }

        [JsonProperty("entity_name")]
        public string EntityName { get; private set; }

        [JsonProperty("entity_type")]
        [JsonConverter(typeof(EnumPermissionEntityJsonConverter))]
        public EnumPermissionEntity EntityType { get; private set; }

        [JsonProperty("fuzzy_entity_name")]
        public string FuzzyEntityName { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("security_role")]
        public string SecurityRole { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

    }

    [System.Serializable]
    public class ListOrganizationUsersRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("email")]
        public string Email { get; private set; }

        [JsonProperty("emails")]
        public string[] Emails { get; private set; }

        [JsonProperty("fuzzy_email")]
        public string FuzzyEmail { get; private set; }

        [JsonProperty("fuzzy_username")]
        public string FuzzyUsername { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("organizations_max")]
        public int OrganizationsMax { get; private set; }

        [JsonProperty("organizations_min")]
        public int OrganizationsMin { get; private set; }

        [JsonProperty("projects_max")]
        public int ProjectsMax { get; private set; }

        [JsonProperty("projects_min")]
        public int ProjectsMin { get; private set; }

        [JsonProperty("sub")]
        public string Sub { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

        [JsonProperty("username")]
        public string Username { get; private set; }

        [JsonProperty("usernames")]
        public string[] Usernames { get; private set; }

    }

    [System.Serializable]
    public class ListOrganizationsRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("display_name")]
        public string DisplayName { get; private set; }

        [JsonProperty("fuzzy_display_name")]
        public string FuzzyDisplayName { get; private set; }

        [JsonProperty("fuzzy_name")]
        public string FuzzyName { get; private set; }

        [JsonProperty("license_state")]
        public string LicenseState { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("people_max")]
        public int PeopleMax { get; private set; }

        [JsonProperty("people_min")]
        public int PeopleMin { get; private set; }

        [JsonProperty("projects_max")]
        public int ProjectsMax { get; private set; }

        [JsonProperty("projects_min")]
        public int ProjectsMin { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

    }

    [System.Serializable]
    public class ListProjectPermissionsRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("entity_id")]
        public string EntityId { get; private set; }

        [JsonProperty("entity_name")]
        public string EntityName { get; private set; }

        [JsonProperty("entity_type")]
        [JsonConverter(typeof(EnumPermissionEntityJsonConverter))]
        public EnumPermissionEntity EntityType { get; private set; }

        [JsonProperty("fuzzy_entity_name")]
        public string FuzzyEntityName { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("security_role")]
        public string SecurityRole { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

    }

    [System.Serializable]
    public class ListProjectUsersRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("email")]
        public string Email { get; private set; }

        [JsonProperty("emails")]
        public string[] Emails { get; private set; }

        [JsonProperty("fuzzy_email")]
        public string FuzzyEmail { get; private set; }

        [JsonProperty("fuzzy_username")]
        public string FuzzyUsername { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organizations_max")]
        public int OrganizationsMax { get; private set; }

        [JsonProperty("organizations_min")]
        public int OrganizationsMin { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("projects_max")]
        public int ProjectsMax { get; private set; }

        [JsonProperty("projects_min")]
        public int ProjectsMin { get; private set; }

        [JsonProperty("sub")]
        public string Sub { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

        [JsonProperty("username")]
        public string Username { get; private set; }

        [JsonProperty("usernames")]
        public string[] Usernames { get; private set; }

    }

    [System.Serializable]
    public class ListProjectsRequest
    {

        [JsonProperty("api_keys_max")]
        public int ApiKeysMax { get; private set; }

        [JsonProperty("api_keys_min")]
        public int ApiKeysMin { get; private set; }

        [JsonProperty("classification")]
        public string Classification { get; private set; }

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("fuzzy_name")]
        public string FuzzyName { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("names")]
        public string[] Names { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("organization_name")]
        public string OrganizationName { get; private set; }

        [JsonProperty("people_max")]
        public int PeopleMax { get; private set; }

        [JsonProperty("people_min")]
        public int PeopleMin { get; private set; }

        [JsonProperty("recordings_max")]
        public int RecordingsMax { get; private set; }

        [JsonProperty("recordings_min")]
        public int RecordingsMin { get; private set; }

        [JsonProperty("type")]
        [JsonConverter(typeof(EnumProjectTypeJsonConverter))]
        public EnumProjectType Type { get; private set; }

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    [System.Serializable]
    public class ListRecordingsRequest
    {

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("max_date")]
        public int MaxDate { get; private set; }

        [JsonProperty("max_duration")]
        public float MaxDuration { get; private set; }

        [JsonProperty("max_events")]
        public int MaxEvents { get; private set; }

        [JsonProperty("max_subjects")]
        public int MaxSubjects { get; private set; }

        [JsonProperty("min_date")]
        public int MinDate { get; private set; }

        [JsonProperty("min_duration")]
        public float MinDuration { get; private set; }

        [JsonProperty("min_events")]
        public int MinEvents { get; private set; }

        [JsonProperty("min_subjects")]
        public int MinSubjects { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("names")]
        public string[] Names { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("organization_ids")]
        public string[] OrganizationIds { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("project_ids")]
        public string[] ProjectIds { get; private set; }

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    [System.Serializable]
    public class ListRolesRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("fuzzy_description")]
        public string FuzzyDescription { get; private set; }

        [JsonProperty("fuzzy_name")]
        public string FuzzyName { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("scope")]
        [JsonConverter(typeof(EnumPermissionScopeJsonConverter))]
        public EnumPermissionScope Scope { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

    }

    [System.Serializable]
    public class ListUsersRequest
    {

        [JsonProperty("created_date_end")]
        public int CreatedDateEnd { get; private set; }

        [JsonProperty("created_date_start")]
        public int CreatedDateStart { get; private set; }

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("email")]
        public string Email { get; private set; }

        [JsonProperty("emails")]
        public string[] Emails { get; private set; }

        [JsonProperty("fuzzy_email")]
        public string FuzzyEmail { get; private set; }

        [JsonProperty("fuzzy_username")]
        public string FuzzyUsername { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organizations_max")]
        public int OrganizationsMax { get; private set; }

        [JsonProperty("organizations_min")]
        public int OrganizationsMin { get; private set; }

        [JsonProperty("projects_max")]
        public int ProjectsMax { get; private set; }

        [JsonProperty("projects_min")]
        public int ProjectsMin { get; private set; }

        [JsonProperty("sub")]
        public string Sub { get; private set; }

        [JsonProperty("updated_date_end")]
        public int UpdatedDateEnd { get; private set; }

        [JsonProperty("updated_date_start")]
        public int UpdatedDateStart { get; private set; }

        [JsonProperty("username")]
        public string Username { get; private set; }

        [JsonProperty("usernames")]
        public string[] Usernames { get; private set; }

    }

    [System.Serializable]
    public class MetadataMatch
    {

        [JsonProperty("path")]
        public string Path { get; private set; }

        [JsonProperty("value")]
        public string Value { get; private set; }

    }

    public enum MetadataRecordingEntity
    {
        Recording = 0,
        Event = 1
    }
    public class MetadataRecordingEntityJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            MetadataRecordingEntity castedVal = (MetadataRecordingEntity)val;
            switch (castedVal)
            {
                case MetadataRecordingEntity.Recording:
                    w.WriteValue("recording");
                    break;
                case MetadataRecordingEntity.Event:
                    w.WriteValue("event");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "recording":
                    return MetadataRecordingEntity.Recording;
                case "event":
                    return MetadataRecordingEntity.Event;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    [System.Serializable]
    public class Organization
    {

        [JsonProperty("available_trials")]
        public int AvailableTrials { get; private set; }

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("deleted_at")]
        public string deletedAt;

        public System.DateTime DeletedAt { get => System.DateTime.Parse(deletedAt); }

        [JsonProperty("display_name")]
        public string DisplayName { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("license")]
        public License License { get; private set; }

        [JsonProperty("license_id")]
        public string LicenseId { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("permissions")]
        public Permission[] Permissions { get; private set; }

        [JsonProperty("persons")]
        public Person[] Persons { get; private set; }

        [JsonProperty("projects")]
        public Project[] Projects { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class OrganizationPermissionsResponse
    {

        [JsonProperty("permissions")]
        public Permission[] Permissions { get; private set; }

        [JsonProperty("request")]
        public ListOrganizationPermissionsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class OrganizationResponse
    {

        [JsonProperty("available_features")]
        public EnumFeaturePermission[] AvailableFeatures { get; private set; }

        [JsonProperty("organization")]
        public Organization Organization { get; private set; }

    }

    [System.Serializable]
    public class OrganizationUsersResponse
    {

        [JsonProperty("request")]
        public ListOrganizationUsersRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

        [JsonProperty("users")]
        public Person[] Users { get; private set; }

    }

    [System.Serializable]
    public class OrganizationsResponse
    {

        [JsonProperty("organizations")]
        public Organization[] Organizations { get; private set; }

        [JsonProperty("request")]
        public ListOrganizationsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class Permission
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("security_role")]
        public SecurityRole SecurityRole { get; private set; }

        [JsonProperty("security_role_id")]
        public string SecurityRoleId { get; private set; }

        [JsonProperty("trackable_entity_id")]
        public string TrackableEntityId { get; private set; }

        [JsonProperty("trackable_entity_type")]
        public string TrackableEntityType { get; private set; }

        [JsonProperty("trackable_group_id")]
        public string TrackableGroupId { get; private set; }

        [JsonProperty("trackable_group_type")]
        public string TrackableGroupType { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class PermissionResponse
    {

        [JsonProperty("permission")]
        public Permission Permission { get; private set; }

    }

    [System.Serializable]
    public class Person
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("customer")]
        public Customer Customer { get; private set; }

        [JsonProperty("customer_id")]
        public string CustomerId { get; private set; }

        [JsonProperty("deleted_at")]
        public string deletedAt;

        public System.DateTime DeletedAt { get => System.DateTime.Parse(deletedAt); }

        [JsonProperty("dev_key")]
        public DevKey DevKey { get; private set; }

        [JsonProperty("email")]
        public string Email { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("organizations")]
        public Organization[] Organizations { get; private set; }

        [JsonProperty("permissions")]
        public Permission[] Permissions { get; private set; }

        [JsonProperty("projects")]
        public Project[] Projects { get; private set; }

        [JsonProperty("state")]
        [JsonConverter(typeof(EnumUserStateJsonConverter))]
        public EnumUserState State { get; private set; }

        [JsonProperty("sub")]
        public string Sub { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

        [JsonProperty("username")]
        public string Username { get; private set; }

    }

    [System.Serializable]
    public class Project
    {

        [JsonProperty("analytics")]
        public Analytics Analytics { get; private set; }

        [JsonProperty("api_keys")]
        public ApiKey[] ApiKeys { get; private set; }

        [JsonProperty("classification")]
        public string Classification { get; private set; }

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("deleted_at")]
        public string deletedAt;

        public System.DateTime DeletedAt { get => System.DateTime.Parse(deletedAt); }

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("license")]
        public License License { get; private set; }

        [JsonProperty("license_id")]
        public string LicenseId { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("organization")]
        public Organization Organization { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("permissions")]
        public Permission[] Permissions { get; private set; }

        [JsonProperty("persons")]
        public Person[] Persons { get; private set; }

        [JsonProperty("recordings")]
        public Recording[] Recordings { get; private set; }

        [JsonProperty("type")]
        [JsonConverter(typeof(EnumProjectTypeJsonConverter))]
        public EnumProjectType Type { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    [System.Serializable]
    public class ProjectPermissionsResponse
    {

        [JsonProperty("permissions")]
        public Permission[] Permissions { get; private set; }

        [JsonProperty("request")]
        public ListProjectPermissionsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class ProjectResponse
    {

        [JsonProperty("available_features")]
        public EnumFeaturePermission[] AvailableFeatures { get; private set; }

        [JsonProperty("project")]
        public Project Project { get; private set; }

    }

    [System.Serializable]
    public class ProjectUsersResponse
    {

        [JsonProperty("request")]
        public ListProjectUsersRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

        [JsonProperty("users")]
        public Person[] Users { get; private set; }

    }

    [System.Serializable]
    public class ProjectsResponse
    {

        [JsonProperty("projects")]
        public Project[] Projects { get; private set; }

        [JsonProperty("request")]
        public ListProjectsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class Recording
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("deleted_at")]
        public string deletedAt;

        public System.DateTime DeletedAt { get => System.DateTime.Parse(deletedAt); }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("project")]
        public Project Project { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("summary")]
        public RecordingSummary Summary { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    public enum RecordingEntity
    {
        Recording = 0,
        Enum = 1,
        Event = 2
    }
    public class RecordingEntityJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            RecordingEntity castedVal = (RecordingEntity)val;
            switch (castedVal)
            {
                case RecordingEntity.Recording:
                    w.WriteValue("recording");
                    break;
                case RecordingEntity.Enum:
                    w.WriteValue("enum");
                    break;
                case RecordingEntity.Event:
                    w.WriteValue("event");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "recording":
                    return RecordingEntity.Recording;
                case "enum":
                    return RecordingEntity.Enum;
                case "event":
                    return RecordingEntity.Event;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    [System.Serializable]
    public class RecordingResponse
    {

        [JsonProperty("recording")]
        public Recording Recording { get; private set; }

    }

    [System.Serializable]
    public class RecordingSummary
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("custom_events")]
        public int CustomEvents { get; private set; }

        [JsonProperty("duration")]
        public double Duration { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("subjects")]
        public int Subjects { get; private set; }

        [JsonProperty("uploaded_at")]
        public string uploadedAt;

        public System.DateTime UploadedAt { get => System.DateTime.Parse(uploadedAt); }

    }

    [System.Serializable]
    public class RecordingsResponse
    {

        [JsonProperty("recordings")]
        public Recording[] Recordings { get; private set; }

        [JsonProperty("request")]
        public ListRecordingsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class RoleResponse
    {

        [JsonProperty("role")]
        public SecurityRole Role { get; private set; }

    }

    [System.Serializable]
    public class RolesResponse
    {

        [JsonProperty("request")]
        public ListRolesRequest Request { get; private set; }

        [JsonProperty("roles")]
        public SecurityRole[] Roles { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class SearchRecordingsRequest
    {

        [JsonProperty("deleted")]
        public bool Deleted { get; private set; }

        [JsonProperty("limit")]
        public int Limit { get; private set; }

        [JsonProperty("max_date")]
        public int MaxDate { get; private set; }

        [JsonProperty("max_duration")]
        public float MaxDuration { get; private set; }

        [JsonProperty("max_events")]
        public int MaxEvents { get; private set; }

        [JsonProperty("max_subjects")]
        public int MaxSubjects { get; private set; }

        [JsonProperty("min_date")]
        public int MinDate { get; private set; }

        [JsonProperty("min_duration")]
        public float MinDuration { get; private set; }

        [JsonProperty("min_events")]
        public int MinEvents { get; private set; }

        [JsonProperty("min_subjects")]
        public int MinSubjects { get; private set; }

        [JsonProperty("names")]
        public string[] Names { get; private set; }

        [JsonProperty("offset")]
        public int Offset { get; private set; }

        [JsonProperty("order_by")]
        public string OrderBy { get; private set; }

        [JsonProperty("organization_id")]
        public string OrganizationId { get; private set; }

        [JsonProperty("organization_ids")]
        public string[] OrganizationIds { get; private set; }

        [JsonProperty("project_id")]
        public string ProjectId { get; private set; }

        [JsonProperty("project_ids")]
        public string[] ProjectIds { get; private set; }

        [JsonProperty("recording_matches")]
        public MetadataMatch[] RecordingMatches { get; private set; }

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    [System.Serializable]
    public class SearchRecordingsResponse
    {

        [JsonProperty("recordings")]
        public Recording[] Recordings { get; private set; }

        [JsonProperty("request")]
        public SearchRecordingsRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

    }

    [System.Serializable]
    public class SecurityGrant
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("scope")]
        [JsonConverter(typeof(EnumPermissionScopeJsonConverter))]
        public EnumPermissionScope Scope { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    [System.Serializable]
    public class SecurityRole
    {

        [JsonProperty("created_at")]
        public string createdAt;

        public System.DateTime CreatedAt { get => System.DateTime.Parse(createdAt); }

        [JsonProperty("description")]
        public string Description { get; private set; }

        [JsonProperty("id")]
        public string Id { get; private set; }

        [JsonProperty("name")]
        public string Name { get; private set; }

        [JsonProperty("scope")]
        [JsonConverter(typeof(EnumPermissionScopeJsonConverter))]
        public EnumPermissionScope Scope { get; private set; }

        [JsonProperty("security_grants")]
        public SecurityGrant[] SecurityGrants { get; private set; }

        [JsonProperty("updated_at")]
        public string updatedAt;

        public System.DateTime UpdatedAt { get => System.DateTime.Parse(updatedAt); }

    }

    public enum TimeSpanWindow
    {
        Week = 0,
        Month = 1,
        ThreeMonths = 2,
        SixMonths = 3,
        Year = 4
    }
    public class TimeSpanWindowJsonConverter : JsonConverter
    {
        public override void WriteJson(JsonWriter w, object val, JsonSerializer s)
        {
            TimeSpanWindow castedVal = (TimeSpanWindow)val;
            switch (castedVal)
            {
                case TimeSpanWindow.Week:
                    w.WriteValue("week");
                    break;
                case TimeSpanWindow.Month:
                    w.WriteValue("month");
                    break;
                case TimeSpanWindow.ThreeMonths:
                    w.WriteValue("three-months");
                    break;
                case TimeSpanWindow.SixMonths:
                    w.WriteValue("six-months");
                    break;
                case TimeSpanWindow.Year:
                    w.WriteValue("year");
                    break;
                default:
                    throw new System.Exception("Unknown value. Living on the dangerous side editing generated code?");
            }
        }

        public override object ReadJson(JsonReader r, System.Type t, object existingValue, JsonSerializer s)
        {
            var enumString = (string)r.Value;
            switch (enumString)
            {
                case "week":
                    return TimeSpanWindow.Week;
                case "month":
                    return TimeSpanWindow.Month;
                case "three-months":
                    return TimeSpanWindow.ThreeMonths;
                case "six-months":
                    return TimeSpanWindow.SixMonths;
                case "year":
                    return TimeSpanWindow.Year;
                default:
                    throw new System.Exception("Unknown value. Perhaps you need to regenerate this code?");
            }
        }

        public override bool CanConvert(System.Type objectType)
        {
            return objectType == typeof(string);
        }
    }

    [System.Serializable]
    public class UpdatedRecording
    {

        [JsonProperty("visibility")]
        [JsonConverter(typeof(EnumVisibilityJsonConverter))]
        public EnumVisibility Visibility { get; private set; }

    }

    [System.Serializable]
    public class UserResponse
    {

        [JsonProperty("user")]
        public Person User { get; private set; }

    }

    [System.Serializable]
    public class UsersResponse
    {

        [JsonProperty("request")]
        public ListUsersRequest Request { get; private set; }

        [JsonProperty("total_size")]
        public int TotalSize { get; private set; }

        [JsonProperty("users")]
        public Person[] Users { get; private set; }

    }

    [System.Serializable]
    public class RuntimeError
    {

        [JsonProperty("code")]
        public int Code { get; private set; }

        [JsonProperty("error")]
        public string Error { get; private set; }

        [JsonProperty("message")]
        public string Message { get; private set; }

    }

}